// This file is a part of MPDN Extensions.
// https://github.com/zachsaw/MPDN_Extensions
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 3.0 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library.
// 
sampler SourceSampler: register(s0);
sampler RTSampler: register(s2);
float2 pixSize : register(c0);
#define getRT(posx, posy) (tex2D(RTSampler, tex + float2(posx, posy) * pixSize).xy)
static float3x3 rgbToHd = {+0.2126000000000000, +0.7152000000000000, +0.0722000000000000,
                           -0.1145721060573400, -0.3854278939426600, +0.5000000000000000,
                           +0.5000000000000000, -0.4541529083058166, -0.0458470916941834};
static float3x3 hdToRgb = {+1.0000000000000000, +0.0000000000000000, +1.5748000000000000,
                           +1.0000000000000000, -0.1873242729306488, -0.4681242729306488,
                           +1.0000000000000000, +1.8556000000000000, +0.0000000000000000};

float4 main(float2 tex : TEXCOORD0) : COLOR
{
  float2 RTc = 0.428 * getRT(0, 0) + 0.143 * (getRT(-1, 0) + getRT(0, -1) + getRT(0, +1) + getRT(+1, 0));
  float3 yuv = mul(rgbToHd, tex2D(SourceSampler, tex).rgb);
  yuv.x = RTc.y + RTc.x * yuv.x;
  return float4(mul(hdToRgb, yuv), 0);
}
